const express = require("express");
const authController = require("../controllers/auth");
const isAuth = require("../middleware/requirelogin");
const router = express.Router();

router.get("/protected", isAuth, authController.checkProtected);

router.post("/signup", authController.postSignup);

router.post("/signin", authController.postSignin);

router.post("/sendotp", authController.sendOTP);

router.post("/getotp", authController.getOTP);

router.post("/forgotpassword", authController.forgotpassword);

router.post("/resetpassword/:_id/:token", authController.resetpassword);

router.get("/resetpassword/:_id/:token", authController.resetpassword);

module.exports = router;
