const express = require('express') ;
const courseController = require('../controllers/course') ;

const isAuth = require('../middleware/requirelogin') ;
const isAdmin = require('../middleware/isAdmin') ;

const router = express.Router() ;

router.post('/addCourse' ,isAuth , isAdmin , courseController.postAddCourse) ;

router.get('/getAllCourses' , courseController.getAllCourses) ;
//NOTE 
//It is a post request
router.post('/getSingleParCourse' , courseController.getSingleParCourse) ;
//NOTE 
//It is a post request
router.post('/getTierCourse' , courseController.getTierCourse) ;
//NOTE 
//It is a post request
router.post('/getMeetSchedule' ,isAuth , courseController.getMeetSchedule) ;

router.get('/getFromRoute' , courseController.getFromRoute) ;

router.post('/addClick' , isAuth , courseController.addClick) ;

module.exports = router ;